// ==============================================================
// RTL generated by Vitis HLS - High-Level Synthesis from C, C++ and OpenCL v2022.1 (64-bit)
// Version: 2022.1
// Copyright (C) Copyright 1986-2022 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="cache_module_cache_module,hls_ip_2022_1,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z020-clg400-1,HLS_INPUT_CLOCK=10.000000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=6.917000,HLS_SYN_LAT=10,HLS_SYN_TPT=none,HLS_SYN_MEM=0,HLS_SYN_DSP=0,HLS_SYN_FF=164,HLS_SYN_LUT=730,HLS_VERSION=2022_1}" *)

module cache_module (
        ap_clk,
        ap_rst,
        ap_start,
        ap_done,
        ap_idle,
        ap_ready,
        address,
        dirty,
        dirty_ap_vld,
        hit,
        hit_ap_vld,
        data,
        data_ap_vld,
        updateSet,
        updateWay,
        newTag,
        updateTagValid,
        newData_address0,
        newData_ce0,
        newData_q0,
        updateDataValid
);

parameter    ap_ST_fsm_state1 = 8'd1;
parameter    ap_ST_fsm_state2 = 8'd2;
parameter    ap_ST_fsm_state3 = 8'd4;
parameter    ap_ST_fsm_state4 = 8'd8;
parameter    ap_ST_fsm_state5 = 8'd16;
parameter    ap_ST_fsm_state6 = 8'd32;
parameter    ap_ST_fsm_state7 = 8'd64;
parameter    ap_ST_fsm_state8 = 8'd128;

input   ap_clk;
input   ap_rst;
input   ap_start;
output   ap_done;
output   ap_idle;
output   ap_ready;
input  [31:0] address;
output   dirty;
output   dirty_ap_vld;
output   hit;
output   hit_ap_vld;
output  [7:0] data;
output   data_ap_vld;
input  [7:0] updateSet;
input  [7:0] updateWay;
input  [31:0] newTag;
input   updateTagValid;
output  [1:0] newData_address0;
output   newData_ce0;
input  [7:0] newData_q0;
input   updateDataValid;

reg ap_done;
reg ap_idle;
reg ap_ready;
reg dirty_ap_vld;
reg hit;
reg hit_ap_vld;
reg data_ap_vld;

(* fsm_encoding = "none" *) reg   [7:0] ap_CS_fsm;
wire    ap_CS_fsm_state1;
reg   [2:0] cacheMemory_address0;
reg    cacheMemory_ce0;
reg   [7:0] cacheMemory_we0;
reg   [63:0] cacheMemory_d0;
wire   [63:0] cacheMemory_q0;
wire   [0:0] updateDataValid_read_read_fu_110_p2;
wire   [0:0] updateTagValid_read_read_fu_116_p2;
wire   [26:0] trunc_ln7_fu_207_p1;
reg   [26:0] trunc_ln7_reg_445;
wire   [5:0] add_ln9_fu_235_p2;
reg   [5:0] add_ln9_reg_450;
reg   [2:0] cacheMemory_addr_reg_455;
wire   [5:0] or_ln11_fu_285_p2;
reg   [5:0] or_ln11_reg_460;
wire    ap_CS_fsm_state3;
wire   [2:0] tmp_fu_297_p2;
reg   [2:0] tmp_reg_465;
wire    ap_CS_fsm_state4;
wire   [26:0] trunc_ln15_1_fu_303_p1;
reg   [26:0] trunc_ln15_1_reg_470;
reg   [2:0] cacheMemory_addr_1_reg_475;
wire    ap_CS_fsm_state5;
wire    ap_CS_fsm_state7;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_done;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_idle;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_ready;
wire   [1:0] grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_address0;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_ce0;
wire   [2:0] grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_address0;
wire    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_ce0;
wire   [7:0] grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_we0;
wire   [63:0] grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_d0;
reg    grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg;
wire   [63:0] zext_ln9_fu_251_p1;
wire   [63:0] zext_ln15_fu_306_p1;
wire   [63:0] idxprom48_fu_349_p1;
wire    ap_CS_fsm_state8;
wire   [0:0] icmp_ln21_fu_368_p2;
wire   [0:0] trunc_ln21_fu_354_p1;
wire    ap_CS_fsm_state2;
wire   [63:0] zext_ln10_fu_280_p1;
wire    ap_CS_fsm_state6;
wire   [63:0] zext_ln17_fu_335_p1;
wire   [2:0] trunc_ln9_fu_211_p1;
wire   [2:0] trunc_ln9_1_fu_223_p1;
wire   [5:0] shl_ln9_1_fu_227_p3;
wire   [5:0] shl_ln9_fu_215_p3;
wire   [2:0] lshr_ln9_fu_241_p4;
wire   [29:0] tmp_3_fu_256_p4;
wire   [31:0] and_ln_fu_266_p3;
wire   [31:0] or_ln10_fu_274_p2;
wire   [2:0] empty_fu_294_p1;
wire   [2:0] trunc_ln15_fu_291_p1;
wire   [2:0] tmp_5_fu_310_p4;
wire   [31:0] tmp1_fu_320_p4;
wire   [31:0] or_ln16_fu_329_p2;
wire   [2:0] bf_lshr_cast_fu_340_p4;
wire   [26:0] trunc_ln21_3_fu_358_p4;
wire   [1:0] tmp_6_fu_373_p4;
wire   [5:0] zext_ln23_cast_fu_382_p4;
wire   [63:0] zext_ln23_fu_392_p1;
wire   [63:0] lshr_ln23_fu_396_p2;
reg   [7:0] ap_NS_fsm;
reg    ap_ST_fsm_state1_blk;
wire    ap_ST_fsm_state2_blk;
wire    ap_ST_fsm_state3_blk;
reg    ap_block_state4_on_subcall_done;
reg    ap_ST_fsm_state4_blk;
wire    ap_ST_fsm_state5_blk;
wire    ap_ST_fsm_state6_blk;
wire    ap_ST_fsm_state7_blk;
wire    ap_ST_fsm_state8_blk;
wire    ap_ce_reg;

// power-on initialization
initial begin
#0 ap_CS_fsm = 8'd1;
#0 grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg = 1'b0;
end

cache_module_cacheMemory_RAM_AUTO_1R1W #(
    .DataWidth( 64 ),
    .AddressRange( 8 ),
    .AddressWidth( 3 ))
cacheMemory_U(
    .clk(ap_clk),
    .reset(ap_rst),
    .address0(cacheMemory_address0),
    .ce0(cacheMemory_ce0),
    .we0(cacheMemory_we0),
    .d0(cacheMemory_d0),
    .q0(cacheMemory_q0)
);

cache_module_cache_module_Pipeline_VITIS_LOOP_11_1 grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198(
    .ap_clk(ap_clk),
    .ap_rst(ap_rst),
    .ap_start(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start),
    .ap_done(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_done),
    .ap_idle(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_idle),
    .ap_ready(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_ready),
    .newData_address0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_address0),
    .newData_ce0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_ce0),
    .newData_q0(newData_q0),
    .or_ln11(or_ln11_reg_460),
    .cacheMemory_address0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_address0),
    .cacheMemory_ce0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_ce0),
    .cacheMemory_we0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_we0),
    .cacheMemory_d0(grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_d0)
);

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst == 1'b1) begin
        grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg <= 1'b0;
    end else begin
        if ((1'b1 == ap_CS_fsm_state3)) begin
            grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg <= 1'b1;
        end else if ((grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_ready == 1'b1)) begin
            grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (((updateDataValid_read_read_fu_110_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state1))) begin
        add_ln9_reg_450[5 : 3] <= add_ln9_fu_235_p2[5 : 3];
        cacheMemory_addr_reg_455 <= zext_ln9_fu_251_p1;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state5)) begin
        cacheMemory_addr_1_reg_475 <= zext_ln15_fu_306_p1;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state3)) begin
        or_ln11_reg_460[5 : 3] <= or_ln11_fu_285_p2[5 : 3];
    end
end

always @ (posedge ap_clk) begin
    if (((updateTagValid_read_read_fu_116_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        tmp_reg_465 <= tmp_fu_297_p2;
        trunc_ln15_1_reg_470 <= trunc_ln15_1_fu_303_p1;
    end
end

always @ (posedge ap_clk) begin
    if ((1'b1 == ap_CS_fsm_state1)) begin
        trunc_ln7_reg_445 <= trunc_ln7_fu_207_p1;
    end
end

always @ (*) begin
    if ((ap_start == 1'b0)) begin
        ap_ST_fsm_state1_blk = 1'b1;
    end else begin
        ap_ST_fsm_state1_blk = 1'b0;
    end
end

assign ap_ST_fsm_state2_blk = 1'b0;

assign ap_ST_fsm_state3_blk = 1'b0;

always @ (*) begin
    if ((1'b1 == ap_block_state4_on_subcall_done)) begin
        ap_ST_fsm_state4_blk = 1'b1;
    end else begin
        ap_ST_fsm_state4_blk = 1'b0;
    end
end

assign ap_ST_fsm_state5_blk = 1'b0;

assign ap_ST_fsm_state6_blk = 1'b0;

assign ap_ST_fsm_state7_blk = 1'b0;

assign ap_ST_fsm_state8_blk = 1'b0;

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state8)) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b0))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state8)) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state7)) begin
        cacheMemory_address0 = idxprom48_fu_349_p1;
    end else if ((1'b1 == ap_CS_fsm_state6)) begin
        cacheMemory_address0 = cacheMemory_addr_1_reg_475;
    end else if ((1'b1 == ap_CS_fsm_state5)) begin
        cacheMemory_address0 = zext_ln15_fu_306_p1;
    end else if ((1'b1 == ap_CS_fsm_state2)) begin
        cacheMemory_address0 = cacheMemory_addr_reg_455;
    end else if ((1'b1 == ap_CS_fsm_state1)) begin
        cacheMemory_address0 = zext_ln9_fu_251_p1;
    end else if (((updateDataValid_read_read_fu_110_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_address0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_address0;
    end else begin
        cacheMemory_address0 = 'bx;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state6) | (1'b1 == ap_CS_fsm_state2) | (1'b1 == ap_CS_fsm_state7) | (1'b1 == ap_CS_fsm_state5) | ((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1)))) begin
        cacheMemory_ce0 = 1'b1;
    end else if (((updateDataValid_read_read_fu_110_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_ce0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_ce0;
    end else begin
        cacheMemory_ce0 = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state6)) begin
        cacheMemory_d0 = zext_ln17_fu_335_p1;
    end else if ((1'b1 == ap_CS_fsm_state2)) begin
        cacheMemory_d0 = zext_ln10_fu_280_p1;
    end else if (((updateDataValid_read_read_fu_110_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_d0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_d0;
    end else begin
        cacheMemory_d0 = 'bx;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state2) | ((updateTagValid_read_read_fu_116_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state6)))) begin
        cacheMemory_we0 = 8'd15;
    end else if (((updateDataValid_read_read_fu_110_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state4))) begin
        cacheMemory_we0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_cacheMemory_we0;
    end else begin
        cacheMemory_we0 = 8'd0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state8) & (trunc_ln21_fu_354_p1 == 1'd1) & (icmp_ln21_fu_368_p2 == 1'd1))) begin
        data_ap_vld = 1'b1;
    end else begin
        data_ap_vld = 1'b0;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_state8) & (trunc_ln21_fu_354_p1 == 1'd1) & (icmp_ln21_fu_368_p2 == 1'd1))) begin
        dirty_ap_vld = 1'b1;
    end else begin
        dirty_ap_vld = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state8)) begin
        if (((trunc_ln21_fu_354_p1 == 1'd1) & (icmp_ln21_fu_368_p2 == 1'd1))) begin
            hit = 1'd1;
        end else if (((trunc_ln21_fu_354_p1 == 1'd0) | (icmp_ln21_fu_368_p2 == 1'd0))) begin
            hit = 1'd0;
        end else begin
            hit = 'bx;
        end
    end else begin
        hit = 'bx;
    end
end

always @ (*) begin
    if ((((1'b1 == ap_CS_fsm_state8) & (trunc_ln21_fu_354_p1 == 1'd1) & (icmp_ln21_fu_368_p2 == 1'd1)) | ((1'b1 == ap_CS_fsm_state8) & ((trunc_ln21_fu_354_p1 == 1'd0) | (icmp_ln21_fu_368_p2 == 1'd0))))) begin
        hit_ap_vld = 1'b1;
    end else begin
        hit_ap_vld = 1'b0;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((updateDataValid_read_read_fu_110_p2 == 1'd0) & (1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state4;
            end else if (((updateDataValid_read_read_fu_110_p2 == 1'd1) & (1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            ap_NS_fsm = ap_ST_fsm_state3;
        end
        ap_ST_fsm_state3 : begin
            ap_NS_fsm = ap_ST_fsm_state4;
        end
        ap_ST_fsm_state4 : begin
            if (((updateTagValid_read_read_fu_116_p2 == 1'd0) & (1'b0 == ap_block_state4_on_subcall_done) & (1'b1 == ap_CS_fsm_state4))) begin
                ap_NS_fsm = ap_ST_fsm_state6;
            end else if (((updateTagValid_read_read_fu_116_p2 == 1'd1) & (1'b0 == ap_block_state4_on_subcall_done) & (1'b1 == ap_CS_fsm_state4))) begin
                ap_NS_fsm = ap_ST_fsm_state5;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state4;
            end
        end
        ap_ST_fsm_state5 : begin
            ap_NS_fsm = ap_ST_fsm_state6;
        end
        ap_ST_fsm_state6 : begin
            ap_NS_fsm = ap_ST_fsm_state7;
        end
        ap_ST_fsm_state7 : begin
            ap_NS_fsm = ap_ST_fsm_state8;
        end
        ap_ST_fsm_state8 : begin
            ap_NS_fsm = ap_ST_fsm_state1;
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign add_ln9_fu_235_p2 = (shl_ln9_1_fu_227_p3 + shl_ln9_fu_215_p3);

assign and_ln_fu_266_p3 = {{tmp_3_fu_256_p4}, {2'd0}};

assign ap_CS_fsm_state1 = ap_CS_fsm[32'd0];

assign ap_CS_fsm_state2 = ap_CS_fsm[32'd1];

assign ap_CS_fsm_state3 = ap_CS_fsm[32'd2];

assign ap_CS_fsm_state4 = ap_CS_fsm[32'd3];

assign ap_CS_fsm_state5 = ap_CS_fsm[32'd4];

assign ap_CS_fsm_state6 = ap_CS_fsm[32'd5];

assign ap_CS_fsm_state7 = ap_CS_fsm[32'd6];

assign ap_CS_fsm_state8 = ap_CS_fsm[32'd7];

always @ (*) begin
    ap_block_state4_on_subcall_done = ((updateDataValid_read_read_fu_110_p2 == 1'd1) & (grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_done == 1'b0));
end

assign bf_lshr_cast_fu_340_p4 = {{address[29:27]}};

assign data = lshr_ln23_fu_396_p2[7:0];

assign dirty = cacheMemory_q0[32'd1];

assign empty_fu_294_p1 = updateWay[2:0];

assign grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_ap_start_reg;

assign icmp_ln21_fu_368_p2 = ((trunc_ln21_3_fu_358_p4 == trunc_ln7_reg_445) ? 1'b1 : 1'b0);

assign idxprom48_fu_349_p1 = bf_lshr_cast_fu_340_p4;

assign lshr_ln23_fu_396_p2 = cacheMemory_q0 >> zext_ln23_fu_392_p1;

assign lshr_ln9_fu_241_p4 = {{add_ln9_fu_235_p2[5:3]}};

assign newData_address0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_address0;

assign newData_ce0 = grp_cache_module_Pipeline_VITIS_LOOP_11_1_fu_198_newData_ce0;

assign or_ln10_fu_274_p2 = (32'd1 | and_ln_fu_266_p3);

assign or_ln11_fu_285_p2 = (6'd4 | add_ln9_reg_450);

assign or_ln16_fu_329_p2 = (tmp1_fu_320_p4 | 32'd1);

assign shl_ln9_1_fu_227_p3 = {{trunc_ln9_1_fu_223_p1}, {3'd0}};

assign shl_ln9_fu_215_p3 = {{trunc_ln9_fu_211_p1}, {3'd0}};

assign tmp1_fu_320_p4 = {{{tmp_5_fu_310_p4}, {trunc_ln15_1_reg_470}}, {2'd0}};

assign tmp_3_fu_256_p4 = {{cacheMemory_q0[31:2]}};

assign tmp_5_fu_310_p4 = {{cacheMemory_q0[31:29]}};

assign tmp_6_fu_373_p4 = {{address[31:30]}};

assign tmp_fu_297_p2 = (empty_fu_294_p1 + trunc_ln15_fu_291_p1);

assign trunc_ln15_1_fu_303_p1 = newTag[26:0];

assign trunc_ln15_fu_291_p1 = updateSet[2:0];

assign trunc_ln21_3_fu_358_p4 = {{cacheMemory_q0[28:2]}};

assign trunc_ln21_fu_354_p1 = cacheMemory_q0[0:0];

assign trunc_ln7_fu_207_p1 = address[26:0];

assign trunc_ln9_1_fu_223_p1 = updateWay[2:0];

assign trunc_ln9_fu_211_p1 = updateSet[2:0];

assign updateDataValid_read_read_fu_110_p2 = updateDataValid;

assign updateTagValid_read_read_fu_116_p2 = updateTagValid;

assign zext_ln10_fu_280_p1 = or_ln10_fu_274_p2;

assign zext_ln15_fu_306_p1 = tmp_reg_465;

assign zext_ln17_fu_335_p1 = or_ln16_fu_329_p2;

assign zext_ln23_cast_fu_382_p4 = {{{{1'd1}, {tmp_6_fu_373_p4}}}, {3'd0}};

assign zext_ln23_fu_392_p1 = zext_ln23_cast_fu_382_p4;

assign zext_ln9_fu_251_p1 = lshr_ln9_fu_241_p4;

always @ (posedge ap_clk) begin
    add_ln9_reg_450[2:0] <= 3'b000;
    or_ln11_reg_460[2:0] <= 3'b100;
end

endmodule //cache_module
